/* hex.c  26-Jan-89  A.J.Travis */

/*
 * based on Alan Philips binary to hex converter for
 * binaries in the Lancaster BBC Micro kermit distribution
 */

#include <stdio.h>

#if MSDOS

#define EOL '\n'

#else

#define EOL '\r'

#endif

#define TRUE 1
#define FALSE 0
#define SAME 0

#define END ":00000001FF%c"

char ibuf[32];
int in;
FILE *out;
unsigned addr;
int i, j;
int cksum;
int rflag;

int main(argc, argv)
int argc;
char *argv[];
{
	if (argc < 3) {
		fprintf(stderr, "usage: hex [-R] infile outfile\n");
		exit(-1);
	}
	rflag = 0;
	if (strcmp(argv[1], "-R") == SAME) {
		rflag++;
		--argc;
		argv++;
	}
	if ((in = open(argv[1], 0)) == -1) {
		fprintf(stderr, "Input file does not exist\n");
		exit(-1);
	}
	if ((out = fopen(argv[2], "w")) == NULL) {
		fprintf(stderr, "Can't open output file\n");
		exit(-1);
	}
	addr = loadaddress();
	while (record())
		;
	fprintf(out, END, EOL);
	close(in);
	fclose(out);
	exit(0);
}

record()
{
	cksum = 0;
	if ((i = read(in, ibuf, 32)) == 0)
		return(FALSE);
	putc(':', out);
	hex(i);
	hex(addr / 256);
	hex(addr % 256);
	hex(0);
	for (j = 0; j < i; j++)
		hex(ibuf[j]);
	hex(-cksum);
	putc(EOL, out);
	addr = addr + i;
	return(TRUE);
}

hex(byte)
int byte;
{
	cksum = (cksum + byte);
	fprintf(out, "%02X", byte & 0xFF);
}

loadaddress()
{
	if (rflag)
		return(0x8000);
	else
		return(0x1902);
}
