/* sh.c  - Small-C command shell
 * -----------------------------
 */

/* 01-Dec-1988  0.70 - A.J.Travis
 * 22-Jun-1991  0.71 - J.G.Harston
 *   Checks any exec file after reading line, closes it if at EOF.
 *   Allows last line of exec file to delete itself to tidy up.
 *   mode forces mode+128, '*' disables escape event, passes return
 *   value from system() to exit(), prints return value from FX1.
 */

#include <stdio.h>

#define SAME 0			/* strcmp() strings equal */
#define LINESIZE 128		/* length of command line + '\0' */
#define LINEMAX 127		/* length of command line */
#define SH_EOF '\004'		/* i/o end of file char */

main()
{
	char *p1, *p2;			/* line pointers */
	int mode;			/* VDU mode */
	int eof;			/* end of file */
	char line[LINESIZE];		/* command line */

	if (eof = (osbyte(1, 0) & 0xFF)) /* get return value */
		printf("Return value: &%02X.\n", eof);

	eof = 0;
	do {
		osbyte(126, 0);		/* clear any escapes */
		fputs("$ ", stdout);	/* prompt */
		p1 = p2 = fgets(line, LINEMAX, stdin);

		/* Close exec file if at end - allows it to delete itself */
		if (eof = (osbyte(198, 0xFF00) & 0xFF))
			if (osbyte(127, eof) & 0xFF)
				system("exec");

		/* clean up command line */
		while (*p2 == ' ')
			++p2;
		while (*p1 = *p2++) {
			if (*p1++ == '\n')
				--p1;
		}

		if (strncmp(line, "mode", 4) == SAME) {
			p1 = line + 4;
			while (*p1 == ' ')
				++p1;
			if (isdigit(*p1)) {
				mode = *p1 - '0';
				vdu(22);
				vdu(mode | 0x80);
				exit(0);	/* resets tcc data stack */
			}
               }

		/* exit on ^D */
		if (*line == SH_EOF)
			eof++;
		else {
			if (*line == '*') {
			osbyte(13,6);		/* disable escape event */
			p1=0xFF00;		/* look for an RTS */
			while (*p1 != 0x60) ++p1;
			*(0x0220)=p1;		/* remove event vector */
			}
		exit(system(line)); 	/* reinstall escape handler */
		}
	}
	while (eof == 0);
	exit(0);
}
